/****************************************************************************
**
** Copyright (C) 2010-2011 Iteco Trading Srl
** All rights reserved.
** Contact: Iteco Trading Srl (info@itecad.it)
**
** This file is part of the Itecad EDA software.
**
** Itecad is free software. You can redistribute it and/or modify it under the terms of
** the GNU Lesser General Public License (LGPLv2.1) as published by the Free Software Foundation
**
** This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
** without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
** See the GNU Lesser General Public License for more details.
**
** You should have received a copy of the GNU Lesser General Public License along with this software;
** if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
** If you have questions regarding the use of this file, please contact
** Iteco Trading Srl at info@itecad.it
**
****************************************************************************/

#include "win_proposed_selection.h"

extern	win_main	*w_main;
extern	myGraphicsView	*GV;

win_proposed_selection::win_proposed_selection(QWidget *parent, Qt::WFlags tipo)
        : QDialog(parent, tipo)
{
	// Se questo QDialog viene creato con tipo == Qt::Dialog allora sono costretto ad avere il ? in alto a destra
	// Ciò forse è un bene perchè mi costringerà ad avere un minimo di help
	// Veder Qt::WindowContextHelpButtonHint per avere maggiori informazioni

	setWindowTitle(tr("Select from list"));	
	//setSizeGripEnabled(true);
	setModal(true);

	QGridLayout	*layout = new QGridLayout(this);
	
	list = new QListWidget(this);
	int row = 0;
	//Inserisco i componenti
	num_comp = w_main->proposed_selection_comp.count();
	current_comp = 0;
	foreach (myComponent *comp, w_main->proposed_selection_comp)
		{
		QListWidgetItem *new_item = new QListWidgetItem(comp->name);
		list->insertItem(row++, new_item);
		}
	//Inserisco gli oggetti
	num_obj = w_main->proposed_selection_obj.count();
	current_obj = 0;
	foreach (myGraphicsItem *obj, w_main->proposed_selection_obj)
		{
		QListWidgetItem *new_item = new QListWidgetItem(xml_write_objtype(obj->tipo, GV->is_sch));
		list->insertItem(row++, new_item);
		}
	//Inserisco i nodi
	num_node = w_main->proposed_selection_node.count();
	current_node = 0;
	foreach (node_data *node, w_main->proposed_selection_node)
		{
		QListWidgetItem *new_item = new QListWidgetItem(tr("node"));
		list->insertItem(row++, new_item);
		}
	list->setCurrentRow(0);
	list_changed(0, 0);
	connect(list,SIGNAL(currentItemChanged(QListWidgetItem *, QListWidgetItem *)),this,SLOT(list_changed(QListWidgetItem *, QListWidgetItem *)));	
	connect(list,SIGNAL(itemDoubleClicked(QListWidgetItem *)),this,SLOT(list_double_clicked(QListWidgetItem *)));	
	layout->addWidget(list,0,0,TRUE,FALSE);
	layout->setSpacing(6);
    layout->setMargin(8);

	connect(this,SIGNAL(closeEvent(QListWidgetItem *, QListWidgetItem *)),this,SLOT(list_changed(QListWidgetItem *, QListWidgetItem *)));	
}

void	win_proposed_selection::select_current()
{
	if (current_comp)
		current_comp->set_selected(!current_comp->is_selected);
	if (current_obj)
                current_obj->set_selected(!current_obj->is_selected);
}

void	win_proposed_selection::list_changed(QListWidgetItem *current, QListWidgetItem *previous)
{
	int row = list->currentRow();

	GV->setUpdatesEnabled(FALSE);

	if (GV->tool == T_SELECT)
		select_current();

	current_comp = 0;
	current_obj = 0;
	current_node = 0;
	if (row < num_comp)
		current_comp = w_main->proposed_selection_comp.at(row);
	else 
		{
		row -= num_comp;
		if (row < num_obj)
			current_obj = w_main->proposed_selection_obj.at(row);
		else
			{
			row -= num_obj;
			current_node = w_main->proposed_selection_node.at(row);
			}
		}
	
	if (GV->tool == T_SELECT)
		select_current();

	GV->do_selection_rect_recalculate = TRUE;
	GV->setUpdatesEnabled(TRUE);
}

void	win_proposed_selection::list_double_clicked(QListWidgetItem *item)
{
	close();
}
