/****************************************************************************
**
** Copyright (C) 2010-2011 Iteco Trading Srl
** All rights reserved.
** Contact: Iteco Trading Srl (info@itecad.it)
**
** This file is part of the Itecad EDA software.
**
** Itecad is free software. You can redistribute it and/or modify it under the terms of
** the GNU Lesser General Public License (LGPLv2.1) as published by the Free Software Foundation
**
** This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
** without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
** See the GNU Lesser General Public License for more details.
**
** You should have received a copy of the GNU Lesser General Public License along with this software;
** if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
** If you have questions regarding the use of this file, please contact
** Iteco Trading Srl at info@itecad.it
**
****************************************************************************/

#ifndef WIN_PROPOSED_SELECTION_H
	#define WIN_PROPOSED_SELECTION_H

        #include <QListWidget>
	#include "tipi_dato.h"
	#include "win_main.h"
	#include "utilities.h"
	
	class win_proposed_selection : public QDialog
	{	
		Q_OBJECT	//Necessario per gestire Signals e Slots	
	public:
		win_proposed_selection(QWidget *parent, Qt::WFlags tipo);
		~win_proposed_selection()
		{}

		QListWidget	*list;

		int		num_comp;
		int		num_obj;
		int		num_node;

		myComponent		*current_comp;
		myGraphicsItem	*current_obj;
		node_data		*current_node;

		void	select_current();

	public slots:	
		void	list_changed(QListWidgetItem *current, QListWidgetItem *previous);
		void	list_double_clicked(QListWidgetItem *item);

	};

#endif
